
# DO source /esarchive/scratch/jramon/GitLab_jramon/auto-s2s/MODULES before opening the R session

setwd("/esarchive/scratch/jramon/GitLab_jramon/auto-s2s/")
source("modules/Loading/Loading.R")
source("modules/Downscaling/Downscaling.R")
source("modules/Calibration/Calibration.R")
source("modules/Skill/Skill.R")
source("modules/Saving/Saving.R")
source("modules/Visualization/Visualization.R")

# use this development to run the analogs function. Also change the Interpolation.R script to 
# not load CDORemap from s2dv.
library(easyNCDF)
library(ncdf4)
library(ClimProjDiags)
source('https://earth.bsc.es/gitlab/es/s2dv/-/raw/master/R/Utils.R')
source('https://earth.bsc.es/gitlab/es/s2dv/-/raw/master/R/CDORemap.R')

recipe_file <- "modules/Loading/testing_recipes/recipe_system5c3s-tas_downscaling.yml"
recipe <- prepare_outputs(recipe_file)

# Load datasets
data <- load_datasets(recipe)

# Downscale datasets
downscaled_data <- downscale_datasets(recipe, data)

# Compute skill
# NOTE: LogReg method does not have member dimension because it provides directly the 
# predicted categories
# The following line should work only for Interpolation, Intbc, Intlr, Analogs
stopifnot(recipe$Analysis$Workflow$Downscaling$type %in% c('int', 'intbc', 'intlr', 'analogs'))
skill_metrics <- lapply(downscaled_data$hcst, function(x) compute_skill_metrics(recipe, x$exp, x$obs))

# Plot downscaled data
plot_data(recipe, downscaled_data = downscaled_data$hcst, data = NULL)

# Plot raw data
my_data <- list()
my_data$fcst <- data$hcst
plot_data(recipe, data = my_data)

# Plot skill data
my_data <- list()
my_data$hcst <- downscaled_data$hcst$bilinear$exp
plot_data(recipe, skill_metrics = skill_metrics$bilinear, data = my_data) #Plot skill metrics

##################################
# EXAMPLE FOR SEASONAL CALIBRATION
##################################
#data <- load_datasets(recipe)
# Calibrate datasets
#calibrated_data <- calibrate_datasets(recipe, data)
# Compute skill metrics
#skill_metrics <- compute_skill_metrics(recipe, calibrated_data$hcst, data$obs)
# Compute percentiles and probability bins
#probabilities <- compute_probabilities(recipe, calibrated_data$hcst)
# Export all data to netCDF
#save_data(recipe, data, calibrated_data, skill_metrics, probabilities)
# Plot data
#plot_data(recipe, data, calibrated_data, skill_metrics, probabilities,
#          significance = T)



